## hol88 2.02.19940316

=== Library/arith/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: arith
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
# ---------------------------------------------------------------------
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f *_ml.l *_ml.o
	@echo "===> library arith: all object code deleted"

clobber:
	rm -f *_ml.l *_ml.o
	@echo "===> library arith: all object code deleted"

# =====================================================================
# Entries for individual files.
# =====================================================================

int_extra_ml.o: int_extra.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `int_extra`;;'\
	     'quit();;' | ${Hol}

string_extra_ml.o: string_extra.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `string_extra`;;'\
	     'quit();;' | ${Hol}

arith_cons_ml.o: int_extra_ml.o arith_cons.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'compilet `arith_cons`;;'\
	     'quit();;' | ${Hol}

term_coeffs_ml.o: arith_cons_ml.o string_extra_ml.o term_coeffs.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'loadf `arith_cons`;;'\
	     'loadf `string_extra`;;'\
	     'compilet `term_coeffs`;;'\
	     'quit();;' | ${Hol}

qconv_ml.o: qconv.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `qconv`;;'\
	     'quit();;' | ${Hol}

decls_ml.o: decls.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `decls`;;'\
	     'quit();;' | ${Hol}

norm_bool_ml.o: term_coeffs_ml.o qconv_ml.o decls_ml.o norm_bool.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'loadf `arith_cons`;;'\
	     'loadf `string_extra`;;'\
	     'loadf `term_coeffs`;;'\
	     'loadf `qconv`;;'\
	     'loadf `decls`;;'\
	     'compilet `norm_bool`;;'\
	     'quit();;' | ${Hol}

norm_arith_ml.o: norm_bool_ml.o norm_arith.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'loadf `arith_cons`;;'\
	     'loadf `string_extra`;;'\
	     'loadf `term_coeffs`;;'\
	     'loadf `qconv`;;'\
	     'loadf `decls`;;'\
	     'loadf `norm_bool`;;'\
	     'compilet `norm_arith`;;'\
	     'quit();;' | ${Hol}

norm_ineqs_ml.o: norm_arith_ml.o norm_ineqs.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'loadf `arith_cons`;;'\
	     'loadf `string_extra`;;'\
	     'loadf `term_coeffs`;;'\
	     'loadf `qconv`;;'\
	     'loadf `decls`;;'\
	     'loadf `norm_bool`;;'\
	     'loadf `norm_arith`;;'\
	     'compilet `norm_ineqs`;;'\
	     'quit();;' | ${Hol}

solve_ineqs_ml.o: norm_ineqs_ml.o solve_ineqs.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'loadf `arith_cons`;;'\
	     'loadf `string_extra`;;'\
	     'loadf `term_coeffs`;;'\
	     'loadf `qconv`;;'\
	     'loadf `decls`;;'\
	     'loadf `norm_bool`;;'\
	     'loadf `norm_arith`;;'\
	     'loadf `norm_ineqs`;;'\
	     'compilet `solve_ineqs`;;'\
	     'quit();;' | ${Hol}

solve_ml.o: solve_ineqs_ml.o solve.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'loadf `arith_cons`;;'\
	     'loadf `string_extra`;;'\
	     'loadf `term_coeffs`;;'\
	     'loadf `qconv`;;'\
	     'loadf `decls`;;'\
	     'loadf `norm_bool`;;'\
	     'loadf `norm_arith`;;'\
	     'loadf `norm_ineqs`;;'\
	     'loadf `solve_ineqs`;;'\
	     'compilet `solve`;;'\
	     'quit();;' | ${Hol}

rationals_ml.o: int_extra_ml.o rationals.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'compilet `rationals`;;'\
	     'quit();;' | ${Hol}

sup-inf_ml.o: rationals_ml.o string_extra_ml.o sup-inf.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'loadf `rationals`;;'\
	     'loadf `string_extra`;;'\
	     'compilet `sup-inf`;;'\
	     'quit();;' | ${Hol}

streams_ml.o: streams.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `streams`;;'\
	     'quit();;' | ${Hol}

sol_ranges_ml.o: sup-inf_ml.o streams_ml.o sol_ranges.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `int_extra`;;'\
	     'loadf `rationals`;;'\
	     'loadf `string_extra`;;'\
	     'loadf `sup-inf`;;'\
	     'loadf `streams`;;'\
	     'compilet `sol_ranges`;;'\
	     'quit();;' | ${Hol}

exists_arith_ml.o: sol_ranges_ml.o norm_ineqs_ml.o exists_arith.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'load_library `reduce`;;'\
	     'loadf `int_extra`;;'\
	     'loadf `arith_cons`;;'\
	     'loadf `string_extra`;;'\
	     'loadf `term_coeffs`;;'\
	     'loadf `qconv`;;'\
	     'loadf `decls`;;'\
	     'loadf `norm_bool`;;'\
	     'loadf `norm_arith`;;'\
	     'loadf `norm_ineqs`;;'\
	     'loadf `rationals`;;'\
	     'loadf `sup-inf`;;'\
	     'loadf `streams`;;'\
	     'loadf `sol_ranges`;;'\
	     'compilet `exists_arith`;;'\
	     'quit();;' | ${Hol}

sub_and_cond_ml.o: decls_ml.o sub_and_cond.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `decls`;;'\
	     'compilet `sub_and_cond`;;'\
	     'quit();;' | ${Hol}

prenex_ml.o: decls_ml.o prenex.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadf `decls`;;'\
	     'compilet `prenex`;;'\
	     'quit();;' | ${Hol}

instance_ml.o: instance.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `instance`;;'\
	     'quit();;' | ${Hol}

gen_arith_ml.o: solve_ml.o exists_arith_ml.o\
                sub_and_cond_ml.o prenex_ml.o instance_ml.o\
                gen_arith.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'load_library `reduce`;;'\
	     'loadf `int_extra`;;'\
	     'loadf `arith_cons`;;'\
	     'loadf `string_extra`;;'\
	     'loadf `term_coeffs`;;'\
	     'loadf `qconv`;;'\
	     'loadf `decls`;;'\
	     'loadf `norm_bool`;;'\
	     'loadf `norm_arith`;;'\
	     'loadf `norm_ineqs`;;'\
	     'loadf `solve_ineqs`;;'\
	     'loadf `solve`;;'\
	     'loadf `rationals`;;'\
	     'loadf `sup-inf`;;'\
	     'loadf `streams`;;'\
	     'loadf `sol_ranges`;;'\
	     'loadf `exists_arith`;;'\
	     'loadf `sub_and_cond`;;'\
	     'loadf `prenex`;;'\
	     'loadf `instance`;;'\
	     'compilet `gen_arith`;;'\
	     'quit();;' | ${Hol}

# =====================================================================
# Main entry
# =====================================================================

all: gen_arith_ml.o
	@echo "===> library arith rebuilt"

=== Library/ind_defs/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: ind_defs
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : compile code
#
#    make clean	    : remove compiled code
#	
#    make clobber   : remove compiled code
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f *_ml.o
	@echo "===> library ind_defs: all object code deleted"

clobber:
	rm -f *_ml.o *_ml.l 
	@echo "===> library ind_defs: all object code deleted"

# =====================================================================
# Entries for individual files.
# =====================================================================

ind-defs_ml.o: ind-defs.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `ind-defs`;;'\
	     'quit();;' | ${Hol}

ind_defs_ml.o: ind-defs_ml.o ind_defs.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `ind_defs`;;'\
	     'quit();;' | ${Hol}


# =====================================================================
# Main entry
# =====================================================================

all: ind_defs_ml.o
	@echo "===> library ind_defs rebuilt"

=== Library/pred_sets/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: pred_sets
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f *_ml.o
	@echo "===> library pred_sets: all object code deleted"

clobber:
	rm -f *_ml.o *_ml.l *.th 
	@echo "===> library pred_sets: all object code and theory files deleted"

# =====================================================================
# Entries for individual files.
# =====================================================================

pred_sets.th: mk_pred_sets.ml 
	rm -f pred_sets.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `mk_pred_sets`;;' | ${Hol} 

gspec_ml.o: pred_sets.th gspec.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'load_theory `pred_sets`;;'\
	     'compilet `gspec`;;'\
	     'quit();;' | ${Hol}

set_ind_ml.o: pred_sets.th set_ind.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'load_theory `pred_sets`;;'\
	     'compilet `set_ind`;;'\
	     'quit();;' | ${Hol}

fset_conv_ml.o: pred_sets.th fset_conv.ml
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'load_theory `pred_sets`;;'\
	     'compilet `fset_conv`;;'\
	     'quit();;' | ${Hol}

# =====================================================================
# Main entry
# =====================================================================

all: pred_sets.th set_ind_ml.o gspec_ml.o fset_conv_ml.o 
	@echo "===> library pred_sets rebuilt"

=== Library/reduce/Makefile ===
# =====================================================================
#
#                MAKEFILE FOR THE HOL LIBRARY: reduce
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all       : create theories and compile code
#
#    make clean     : remove only compiled code
#
#    make clobber   : remove both theories and compiled code
#
#    [In fact there are no theories in this library]
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

all: reduce_ml.o;

clean:; rm -f boolconv_ml.o arithconv_ml.o reduce_ml.o

clobber: clean;

reduce_ml.o: arithconv_ml.o boolconv_ml.o reduce.ml;    \
    echo 'set_flag(`abort_when_fail`,true);;'           \
         'compilet `reduce`;;'                          \
         'quit();;' | ${Hol}

arithconv_ml.o: arithconv.ml;                           \
    echo 'set_flag(`abort_when_fail`,true);;'           \
         'compilet `arithconv`;;'                       \
         'quit();;' | ${Hol}

boolconv_ml.o: boolconv.ml;                             \
    echo 'set_flag(`abort_when_fail`,true);;'           \
         'compilet `boolconv`;;'                        \
         'quit();;' | ${Hol}

=== Library/taut/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: taut
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
# ---------------------------------------------------------------------
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f taut_check_ml.o taut_check_ml.l
	@echo "===> library taut: all object code deleted"

clobber:
	rm -f taut_check_ml.o taut_check_ml.l
	@echo "===> library taut: all object code deleted"

# =====================================================================
# Entries for individual files.
# =====================================================================

taut_check_ml.o: taut_check.ml 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `taut_check`;;'\
	     'quit();;' | ${Hol}

# =====================================================================
# Main entry
# =====================================================================

all: taut_check_ml.o
	@echo "===> library taut rebuilt"

=== Library/window/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: window
#
# $Id: Makefile,v 3.1 1993/12/07 14:15:19 jg Exp $
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
#    make decimate  : remove theories, compiled code and source code
#                     that isn't different to that in REVISION.
#
#    make destroy   : remove theories, compiled code and source code.
#                     HANDLE WITH CARE
#
#    make source    : check out the source code (see REVISION)
#
# ---------------------------------------------------------------------
# MACROS:
#
#    HOL            : the pathname of the version of hol used
#    SOURCE         : all the source files
#    REVISION       : The rcs revision of the source code to get
# =====================================================================

HOL=../../hol

SOURCE=basic_close.ml imp_close.ml mk_win_th.ml thms.ml eq_close.ml	\
	inter.ml ml_ext.ml win.ml load_code.ml tables.ml window.ml	\
	hol_ext.ml load_window.ml tactic.ml xlabel.ml

REVISION=

# =====================================================================
# Basic functions.
# =====================================================================

all: window_ml.o xlabel_ml.o tactic_ml.o
	@echo "===> library window built"

source: ${SOURCE}

clean:
	rm -f *.l *.c *.o *.h *.data
	@echo "===> library window: all object code deleted"

clobber:
	rm -f *.l *.c *.o *.th *.h *.data
	@echo "===> library window: all object code and theory files deleted"

#decimate:
#	rm -f *.l *.c *.o *.th *.h *.data
#	rcsclean -r${REVISION} ${SOURCE}
#	@echo "===> library window: all source object code and theories deleted"
#
#destroy:
#	rm -f *.l *.c *.o *.th *.h *.data *.i *.s *.ir
#	rm -f ${SOURCE}
#	@echo "===> library pair: all source, object code and theories deleted"

.FAILED:
	@echo "===> library window build failed"

.DEFAULT:
	co -r${REVISION} $@

# =====================================================================
# Entries for individual files.
# =====================================================================


win.th: mk_win_th.ml
	rm -f win.th
	echo 'set_flag(`abort_when_fail`,true);;'	\
	'loadt `mk_win_th`;;'				\
	'quit ();;' | ${HOL}

thms_ml.o: thms.ml win.th
	echo 'set_flag(`abort_when_fail`,true);;'	\
	'load_theory `win`;;'				\
        'compilet `thms`;;'				\
        'quit();;' | ${HOL}

ml_ext_ml.o: ml_ext.ml
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'compilet `ml_ext`;;'				\
        'quit();;' | ${HOL}

hol_ext_ml.o: hol_ext.ml win.th thms_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
	'load_theory `win`;;'				\
        'loadf `thms`;;'				\
        'compilet `hol_ext`;;'				\
        'quit();;' | ${HOL}

tables_ml.o: tables.ml win.th thms_ml.o hol_ext_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
	'load_theory `win`;;'				\
        'loadf `thms`;;'				\
        'loadf `hol_ext`;;'				\
        'compilet `tables`;;'				\
        'quit();;' | ${HOL}

win_ml.o: win.ml ml_ext_ml.o win.th thms_ml.o hol_ext_ml.o tables_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `ml_ext`;;'				\
	'load_theory `win`;;'				\
        'loadf `thms`;;'				\
        'loadf `hol_ext`;;'				\
        'loadf `tables`;;'				\
        'compilet `win`;;'				\
        'quit();;' | ${HOL}

basic_close_ml.o: basic_close.ml win.th thms_ml.o hol_ext_ml.o tables_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
	'load_theory `win`;;'				\
        'loadf `thms`;;'				\
        'loadf `hol_ext`;;'				\
        'loadf `tables`;;'				\
        'compilet `basic_close`;;'			\
        'quit();;' | ${HOL}

eq_close_ml.o: eq_close.ml win.th thms_ml.o hol_ext_ml.o tables_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
	'load_theory `win`;;'				\
        'loadf `thms`;;'				\
        'loadf `hol_ext`;;'				\
        'loadf `tables`;;'				\
        'compilet `eq_close`;;'				\
        'quit();;' | ${HOL}

imp_close_ml.o: imp_close.ml win.th thms_ml.o hol_ext_ml.o tables_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
	'load_theory `win`;;'				\
        'loadf `thms`;;'				\
        'loadf `hol_ext`;;'				\
        'loadf `tables`;;'				\
        'compilet `imp_close`;;'			\
        'quit();;' | ${HOL}

inter_ml.o: inter.ml ml_ext_ml.o win.th thms_ml.o	\
		hol_ext_ml.o tables_ml.o win_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `ml_ext`;;'				\
	'load_theory `win`;;'				\
        'loadf `thms`;;'				\
        'loadf `hol_ext`;;'				\
        'loadf `tables`;;'				\
        'loadf `win`;;'					\
        'compilet `inter`;;'				\
        'quit();;' | ${HOL}

load_code_ml.o: load_code.ml ml_ext_ml.o win.th thms_ml.o hol_ext_ml.o	\
			tables_ml.o basic_close_ml.o eq_close_ml.o	\
			imp_close_ml.o win_ml.o inter_ml.o 
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'load_theory `win`;;'				\
        'compilet `load_code`;;'			\
        'quit();;' | ${HOL}

load_window_ml.o: load_window.ml load_code_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'compilet `load_window`;;'			\
        'quit();;' | ${HOL}

window_ml.o: window.ml win.th load_code_ml.o load_window_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'compilet `window`;;'				\
        'quit();;' | ${HOL}

xlabel_ml.o: xlabel.ml ml_ext_ml.o win.th thms_ml.o	\
		hol_ext_ml.o tables_ml.o win_ml.o inter_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `ml_ext`;;'				\
	'load_theory `win`;;'				\
        'loadf `thms`;;'				\
        'loadf `hol_ext`;;'				\
        'loadf `tables`;;'				\
        'loadf `win`;;'					\
        'loadf `inter`;;'				\
        'compilet `xlabel`;;'				\
        'quit();;' | ${HOL}

tactic_ml.o: tactic.ml ml_ext_ml.o win.th thms_ml.o	\
		hol_ext_ml.o tables_ml.o win_ml.o inter_ml.o
	echo 'set_flag(`abort_when_fail`,true);;'	\
        'loadf `ml_ext`;;'				\
		'load_theory `win`;;'			\
        'loadf `thms`;;'				\
        'loadf `hol_ext`;;'				\
        'loadf `tables`;;'				\
        'loadf `win`;;'					\
        'loadf `inter`;;'				\
        'compilet `tactic`;;'				\
        'quit();;' | ${HOL}

=== Manual/Tutorial/Makefile ===
# =====================================================================
# Makefile for the hol TUTORIAL
# =====================================================================

default:
	@echo "INSTRUCTIONS: Type \"make all\" to make the tutorial"

clean:
	rm -f *.dvi *.aux *.toc *.log 

tutorial:
	latex tutorial.tex 

all:
	make clean; make tutorial; make tutorial

=== Training/course/Makefile ===
#=====================================================================
# Makefile for typesetting the HOL course slides.
# =====================================================================

default: 
	@echo "Type \"make all\" to typeset the HOL course slides"

intro.dvi: intro.tex
	latex intro.tex

logicA.dvi: logicA.tex
	latex logicA.tex

logicB.dvi: logicB.tex
	latex logicB.tex

macros.dvi: macros.tex
	latex macros.tex

ml.dvi: ml.tex
	latex ml.tex

primrec.dvi: primrec.tex
	latex primrec.tex

systemA.dvi: systemA.tex
	latex systemA.tex

systemB.dvi: systemB.tex
	latex systemB.tex

thmproveA.dvi: thmproveA.tex
	latex thmproveA.tex

thmproveB.dvi: thmproveB.tex
	latex thmproveB.tex

tydefs.dvi: tydefs.tex
	latex tydefs.tex

all: intro.dvi logicA.dvi logicB.dvi ml.dvi primrec.dvi systemA.dvi\
     systemB.dvi thmproveA.dvi thmproveB.dvi tydefs.dvi
	echo "course made"

=== contrib/Predicate/Makefile ===
Hol=/usr/groups/hol/HOL21/bin/hol
noweave=NOWEB/bin/noweave
notangle=NOWEB/bin/notangle

TexPred: predicate.nw
	rm -f predicate.tex predicate.log predicate.aux predicate.dvi
	${noweave} -l predicate.nw > predicate.tex
	@echo "DCG predicate>: LATEX source produced"

LPred: predicate.nw
	rm -f predicate.ml
	${notangle} -Rmyloader predicate.nw > predicate.ml
	@echo "DCG predicate>: personal loader source produced"

PubLPred: predicate.nw
	rm -f predicate.ml
	${notangle} -Rloader predicate.nw > predicate.ml
	@echo "DCG predicate>: public loader source produced"

Pred: predicate.nw
	rm -f mk_predicate.ml
	${notangle} -Rpredicate predicate.nw > mk_predicate.ml
	@echo "DCG predicate>: HOL source produced"

SPred: predicate.nw
	rm -f predicate_SUP.ml
	${notangle} -RCYAN-and-JADE-tactics predicate.nw > predicate_SUP.ml
	@echo "DCG predicate>: support file produced"

SPredMisc: predicate.nw
	rm -f my_misc.ml
	${notangle} -Rmymisc predicate.nw > my_misc.ml
	@echo "DCG predicate>: my_misc source produced"

TPred: mk_predicate.ml
	rm -f predicate.th
	echo ' set_flag(`abort_when_fail`,true);;'\
	' loadt `mk_predicate`;;' | ${Hol}

PackPred:
	make PubLPred
	rm -f PACKPred
	shar NOWEB.dir predicate.nw predicate.tex predicate.ml mk_predicate.ml my_misc.ml OLD_RES.ml predicate_SUP.ml UNITYsty.tex noweb.sty Pred_README Makefile > PACKPred
	make LPred

=== contrib/bags/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: bags
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

Hol=../../hol

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f *_ml.o *_ml.l
	@echo "===> library bags: all object code deleted"

clobber:
	rm -f *_ml.o *_ml.l *.th 
	@echo "===> library bags: all object code and theory files deleted"

# =====================================================================
# Entries for individual files.
# =====================================================================

more_arithmetic.th: mk_more_arithmetic.ml 
	rm -f more_arithmetic.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `mk_more_arithmetic`;;' | ${Hol} 

bags.th: more_arithmetic.th mk_bags.ml 
	rm -f bags.th
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'loadt `mk_bags`;;' | ${Hol} 

# =====================================================================
# Main entry
# =====================================================================

all: more_arithmetic.th bags.th
	@echo "===> library bags rebuilt"

=== contrib/convert/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: convert
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
# ---------------------------------------------------------------------
# MACROS:
#
#    Hol            : the pathname of the version of hol used
#
#    OBJECTS        : the things to make 
# =====================================================================

Hol=../../hol
OBJECTS = unwind_ml.o unfold_ml.o prune_ml.o conv_package_ml.o more_conv_ml.o

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f $(OBJECTS)
	@echo "===> library convert: all object code deleted"

clobber:
	rm -f $(OBJECTS)
	@echo "===> library convert: all object code deleted"

# =====================================================================
# Entries for individual files.
# =====================================================================

unwind_ml.o: unwind.ml 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `unwind`;;'\
	     'quit();;' | ${Hol}

more_conv_ml.o: more_conv.ml 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `more_conv`;;'\
	     'quit();;' | ${Hol}

unfold_ml.o: unfold.ml 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `unfold`;;'\
	     'quit();;' | ${Hol}

prune_ml.o: prune.ml 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `prune`;;'\
	     'quit();;' | ${Hol}

conv_package_ml.o: conv_package.ml 
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'compilet `conv_package`;;'\
	     'quit();;' | ${Hol}

# =====================================================================
# Main entry.
# =====================================================================

all: $(OBJECTS)
	@echo "===> library convert rebuilt"

=== contrib/eval/Makefile ===
# =====================================================================
#
# 		 MAKEFILE FOR THE HOL LIBRARY: eval
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all	    : create theories and compile code
#
#    make clean	    : remove only compiled code
#	
#    make clobber   : remove both theories and compiled code
#
# ---------------------------------------------------------------------
# MACROS:
#
#    Hol         : the pathname of the version of hol used
#
#    LispType    : the type of the lisp system, cl or franz
#
#    Obj         : the default filename extension for compiled lisp files,
#		   for franz it is o, for common lisp it depends on the 
#		   implementation
#
#    Lisp        : the pathname of the common lisp system (not used for franz)
#
#    Liszt       : the pathname of the franz lisp compiler (not used for cl)
#
#    LispDir     : the pathname of the hol lisp directory
# =====================================================================

Hol=../../hol
LispType=franz
Obj=o
Lisp=../../../akcl/saved_kcl_sun3
Liszt=/usr/groups/hol/franz/bin/liszt
LispDir=../../lisp

Allegro_Case=:case-insensitive-upper

# =====================================================================
# Cleaning functions.
# =====================================================================

clean:
	rm -f *_ml.o *_ml.l *.${Obj}
	@echo "===> library eval: all object code deleted"

clobber:
	rm -f *_ml.o *_ml.l *.${Obj}
	@echo "===> library eval: all object code deleted"


# =====================================================================
# Entries for individual files.
# =====================================================================

eval.$(Obj): eval.l
	rm -f f-macro.$(Obj); ln -s $(LispDir)/f-macro.$(Obj) .
	rm -f f-ol-rec.$(Obj); ln -s $(LispDir)/f-ol-rec.$(Obj) .
	rm -f genmacs.$(Obj); ln -s $(LispDir)/genmacs.$(Obj) .
	rm -f f-$(LispType).$(Obj); ln -s $(LispDir)/f-$(LispType).$(Obj) .
	if [ $(LispType) = cl ]; then\
	  echo '#+allegro (set-case-mode $(Allegro_Case))'\
	       '(load "f-cl") (compile-file "eval.l") (quit)'\
	       | $(Lisp); else\
	  $(Liszt) eval.l; fi

dml-eval.$(Obj): dml-eval.l
	rm -f f-macro.$(Obj); ln -s $(LispDir)/f-macro.$(Obj) .
	rm -f f-ol-rec.$(Obj); ln -s $(LispDir)/f-ol-rec.$(Obj) .
	rm -f genmacs.$(Obj); ln -s $(LispDir)/genmacs.$(Obj) .
	rm -f f-$(LispType).$(Obj); ln -s $(LispDir)/f-$(LispType).$(Obj) .
	if [ $(LispType) = cl ]; then\
	  echo '#+allegro (set-case-mode $(Allegro_Case))'\
	       '(load "f-cl") (compile-file "dml-eval.l") (quit)'\
	       | $(Lisp); else\
	  $(Liszt) dml-eval.l; fi

wordn_ml.o: wordn.ml eval.$(Obj) dml-eval.$(Obj)
	echo 'set_flag(`abort_when_fail`,true);;'\
	     'lisp `(load "eval")`;;'\
	     'lisp `(load "dml-eval")`;;'\
	     'compilet `wordn`;;'\
	     'quit();;' | ${Hol}

# =====================================================================
# Main entry
# =====================================================================

all: eval.$(Obj) dml-eval.$(Obj) wordn_ml.o
	@echo "===> library eval rebuilt"

=== debian/changelog ===
hol88 (2.02.19940316-19) unstable; urgency=low

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Sat, 16 Nov 2013 18:01:29 +0000

hol88 (2.02.19940316-18) unstable; urgency=low

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Sat, 12 Oct 2013 14:23:29 +0000

hol88 (2.02.19940316-17) unstable; urgency=low

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 24 Sep 2013 18:57:50 +0000

hol88 (2.02.19940316-16) unstable; urgency=low

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 07 Aug 2013 21:26:12 +0000

hol88 (2.02.19940316-15) unstable; urgency=low

  * lintian fixes
  * 3.0 quilt source format

 -- Camm Maguire <camm@debian.org>  Wed, 11 Apr 2012 18:43:47 +0000

hol88 (2.02.19940316-14) unstable; urgency=low

  * rebuild against latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 17 Jan 2012 19:45:44 +0000

hol88 (2.02.19940316-13) unstable; urgency=low

  * build depend on latest gcl

 -- Camm Maguire <camm@debian.org>  Fri, 05 Nov 2010 16:09:55 +0000

hol88 (2.02.19940316-12) unstable; urgency=low

  * remove stray raw_*_map files

 -- Camm Maguire <camm@debian.org>  Thu, 21 Oct 2010 19:59:51 +0000

hol88 (2.02.19940316-11) unstable; urgency=low

  * build-dep on latest gcl
  * Bug fix: "[mips] empty package", thanks to Jakub Wilk (Closes:
    #597140).
  * Bug fix: "FTBFS on mipsel: Unrecoverable error: Segmentation
    violation..", thanks to Cyril Brulebois (Closes: #599986).
  * Bug fix: "FTBFS on hppa: /bin/sh: ././raw_hol_map: Permission denied",
    thanks to Cyril Brulebois (Closes: #599987).

 -- Camm Maguire <camm@debian.org>  Thu, 21 Oct 2010 14:34:13 +0000

hol88 (2.02.19940316-10) unstable; urgency=low

  * rebuild against newest gcl

 -- Camm Maguire <camm@debian.org>  Sat, 25 Sep 2010 15:19:33 +0000

hol88 (2.02.19940316-9) unstable; urgency=low

  * Bug fix: "replacing libreadline5-dev build dependency with
    libreadline-dev", thanks to Matthias Klose (Closes: #553782).
  * Bug fix: "hol88 crashes with segfault", thanks to Benedikt Ahrens
    (Closes: #508908).

 -- Camm Maguire <camm@debian.org>  Sun, 03 Jan 2010 20:48:22 +0000

hol88 (2.02.19940316-8) unstable; urgency=low

  * Bug fix: "FTBFS: LaTeX Error: \begin{document} ended by
    \end{theindex}", thanks to Chris Lamb (Closes: #484983).
  * Bug fix: "hol88: bashism in debian/rules", thanks to Raphael Geissert
    (Closes: #477583).

 -- Camm Maguire <camm@sacrifice.m.enhanced.com>  Sat, 02 Aug 2008 13:23:41 +0000

hol88 (2.02.19940316-7) unstable; urgency=low

  * Bug fix: "hol88: empty package on arm", thanks to Niko Tyni (Closes:
    #448843). Rebuild against latest gcl

 -- Camm Maguire <camm@enhanced.com>  Mon, 03 Dec 2007 09:18:22 -0500

hol88 (2.02.19940316-6) unstable; urgency=low

  * build-depend on texlive-latex-base
  * Bug fix: "hol88: package content changed if build twice or more times
    in a row", thanks to Patrick Winnertz (Closes: #441710). preserve
    debian/site_ml_orig
  * Bug fix: "hol88: dangling symlinks", thanks to Ian Zimmerman (Closes:
    #442282). write absolute paths in first entry in links files

 -- Camm Maguire <camm@enhanced.com>  Wed, 24 Oct 2007 14:01:30 -0400

hol88 (2.02.19940316-5) unstable; urgency=low

  * Fix patch mechanism for non native relocs

 -- Camm Maguire <camm@enhanced.com>  Mon,  4 Dec 2006 10:39:08 -0500

hol88 (2.02.19940316-4) unstable; urgency=low

  * Proper build deps for non-native-reloc arches

 -- Camm Maguire <camm@enhanced.com>  Sat,  2 Dec 2006 23:28:42 -0500

hol88 (2.02.19940316-3) unstable; urgency=low

  * Fix native-reloc target, Closes: #401321

 -- Camm Maguire <camm@enhanced.com>  Sat,  2 Dec 2006 17:58:39 -0500

hol88 (2.02.19940316-2) unstable; urgency=low

  * redefine ml-save to use si::save-system, and si::*top-level-hook*.
    Fixes amd64 and sparc builds
  * patch Makefile and make-user-init function (from gcl cvs head) to
    support build on systems without native object relocation. Closes:
    #400063.

 -- Camm Maguire <camm@enhanced.com>  Tue, 28 Nov 2006 16:30:04 -0500

hol88 (2.02.19940316-1) unstable; urgency=low

  * Initial release

 -- Camm Maguire <camm@enhanced.com>  Wed, 18 Oct 2006 13:36:15 -0400

=== debian/control ===
Source: hol88
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: debhelper (>= 9), gcl (>= 2.6.10-1), texlive-latex-base, libgmp3-dev, libreadline-dev, libxmu-dev, libxaw7-dev
Standards-Version: 3.9.4

Package: hol88
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Higher Order Logic, system image
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-source
Architecture: all
Depends: ${misc:Depends}
Description: Higher Order Logic, source files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-help
Architecture: all
Depends: ${misc:Depends}
Description: Higher Order Logic, online help files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-library
Architecture: any
Depends: ${misc:Depends}
Description: Higher Order Logic, binary library modules
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-library-source
Architecture: all
Depends: ${misc:Depends}
Description: Higher Order Logic, library source files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-library-help
Architecture: all
Depends: ${misc:Depends}
Description: Higher Order Logic, library online help files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-contrib-source
Architecture: all
Depends: ${misc:Depends}
Description: Higher Order Logic, user contributed source
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-contrib-help
Architecture: all
Depends: ${misc:Depends}
Description: Higher Order Logic, user contributed online help files
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

Package: hol88-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for hol88
 The HOL System is an environment for interactive theorem proving in a
 higher-order logic. Its most outstanding feature is its high degree
 of programmability through the meta-language ML. The system has a
 wide variety of uses from formalizing pure mathematics to
 verification of industrial hardware. Academic and industrial sites
 world-wide are using HOL.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=hol88
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
#	cat debian/dash.p | patch -p1
	touch configure-stamp


build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp 

	echo '#-native-reloc(bye -1)' | gcl || cat debian/gcl_patch.l debian/gcl_save.l | gcl
	PATH=$$(pwd):$$PATH $(MAKE) all
	find -name "raw_*_map" -exec rm {} \;
	for i in $$(find -maxdepth 1 -name "*hol*"); do \
		printf 'install `'/usr/share/$(PD)'`;;\nlisp `(ml-save "foo")`;;\n' | ./$$i &&\
		mv foo $$i; done
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp 


	for i in Manual/Tutorial/ack.tex Manual/Reference/ack.tex Manual/Description/ack.tex; do\
		ln -snf ../Latex/ack.tex $$i ; done
	for i in $$(find Library -name index.tex) Library/pred_sets/Manual/theorems.tex Library/record_proof/Manual/record_proof.ind ; do\
		[ -e $$i.sve ] || cp $$i $$i.sve ; done
	$(MAKE) -C Manual all
	touch $@

INSTALLA:=$(addprefix debian/,$(addsuffix .install,\
	hol88 hol88-library))
INSTALLI:=$(addprefix debian/,$(addsuffix .install,\
	hol88-source hol88-help hol88-library-source\
	hol88-library-help hol88-contrib-source hol88-contrib-help hol88-doc))
LINKS:=$(addprefix debian/,$(addsuffix .links,hol88 hol88-library))

clean:
	dh_testdir
	dh_testroot

#	! [ -e configure-stamp ] || cat debian/dash.p | patch -p1 -R
	rm -f build-arch-stamp build-indep-stamp configure-stamp

	[ ! -f Makefile ] || $(MAKE) clean
	[ ! -f Makefile ] || $(MAKE) clobber
	for i in $$(find Library -name index.tex) Library/pred_sets/Manual/theorems.tex Library/record_proof/Manual/record_proof.ind ; do\
		[ -e $$i.sve ] || cp $$i $$i.sve ; done
	[ ! -f Makefile ] || $(MAKE) -C Manual clean

	[ ! -f Makefile ] || for i in $$(find Library -name Manual); do $(MAKE) -C $$i clean ; done
	find -name X.tex -exec rm -rf {} \;

	dh_clean -X./ml/site.ml.orig -X./contrib/tooltool/Makefile.orig \
		 -X./contrib/tooltool/events.c.orig -X./contrib/tooltool/func_fix.c.orig \
	         -X./contrib/tooltool/lex.c.orig -X./contrib/tooltool/parse.y.orig \
		 -X./contrib/tooltool/patchlevel.h.orig -X./contrib/tooltool/windows.c.orig \
		 -X./contrib/Xhelp/hol_apro.orig -X./contrib/Xhelp/hol_ref.orig \
		 -X./contrib/Xhelp/xholhelp.h.orig -X./contrib/Xhelp/hol_thm.orig

	for i in $$(find Library -name "*.sve") ; do mv $$i $$(echo $$i | sed "s,\.sve,,1"); done

	rm -f $(INSTALLA) $(INSTALLI) $(LINKS) debian/hol88.sh
	find -name "*.dvi" -exec rm {} \;
	rm -f Manual/Tutorial/ack.tex Manual/Reference/ack.tex Manual/Description/ack.tex
	rm -f Manual/Covers/titlepages.ps Manual/Covers/endpages.ps
	rm -f bm.l foo* gcl ./lisp/f-ol-syntax.data
	cp debian/site_ml_orig ml/site.ml.orig


debian/hol88.install:: 
	find -maxdepth 1 -name "*hol*" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
	echo debian/hol88.sh usr/bin >>$@
debian/hol88-source.install:: 
	find lisp -name "*.l" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find ml -type f -name "*ml" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find theories -type f -name "*ml" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find theories -type f -name "*th" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
debian/hol88-help.install:: 
	find help -name "*.doc" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/hol88-library.install:: 
	find Library -name "*.o" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
debian/hol88-library-source.install:: 
	find Library -name "*.ml" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
debian/hol88-library-help.install:: 
	find Library -name "*.doc" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/hol88-contrib-source.install:: 
	find contrib -name "*.ml" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find contrib -name "Makefile" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
debian/hol88-contrib-help.install:: 
	find contrib -name "*.doc" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/hol88-doc.install:: 
	find Manual -name "*dvi" | grep -v makeindex | grep -v psfig | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/doc/hol88-doc/%s\n",$$1,a);}' >>$@
	find Manual -name "*ps" | grep -v makeindex | grep -v psfig | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/doc/hol88-doc/%s\n",$$1,a);}' >>$@


debian/hol88.links:: 
	find * -maxdepth 0 -name "*hol*" | awk '{printf("/usr/lib/$(PD)/%s usr/share/$(PD)/%s\n",$$1,$$1);}' >>$@
debian/hol88-library.links:: 
	find Library -name "*.o" | awk '{printf("/usr/lib/$(PD)/%s usr/share/$(PD)/%s\n",$$1,$$1);}' >>$@


debian/hol88.sh:
	echo "#!/bin/bash" >$@
	echo >>$@
	echo "exec /usr/lib/$(PD)/hol" >>$@
	chmod 755 $@


install: install-indep install-arch
install-indep: $(INSTALLI)
	dh_testdir
	dh_testroot
	dh_prep -i -X./ml/site.ml.orig -X./contrib/tooltool/Makefile.orig \
		 -X./contrib/tooltool/events.c.orig -X./contrib/tooltool/func_fix.c.orig \
	         -X./contrib/tooltool/lex.c.orig -X./contrib/tooltool/parse.y.orig \
		 -X./contrib/tooltool/patchlevel.h.orig -X./contrib/tooltool/windows.c.orig \
		 -X./contrib/Xhelp/hol_apro.orig -X./contrib/Xhelp/hol_ref.orig \
		 -X./contrib/Xhelp/xholhelp.h.orig -X./contrib/Xhelp/hol_thm.orig

	dh_installdirs -i

	dh_install -i

install-arch: $(INSTALLA) $(LINKS) debian/hol88.sh
	dh_testdir
	dh_testroot
	dh_prep -s -X./ml/site.ml.orig -X./contrib/tooltool/Makefile.orig \
		 -X./contrib/tooltool/events.c.orig -X./contrib/tooltool/func_fix.c.orig \
	         -X./contrib/tooltool/lex.c.orig -X./contrib/tooltool/parse.y.orig \
		 -X./contrib/tooltool/patchlevel.h.orig -X./contrib/tooltool/windows.c.orig \
		 -X./contrib/Xhelp/hol_apro.orig -X./contrib/Xhelp/hol_ref.orig \
		 -X./contrib/Xhelp/xholhelp.h.orig -X./contrib/Xhelp/hol_thm.orig

	dh_installdirs -s

	dh_install -s

	mv debian/hol88/usr/bin/hol88.sh debian/hol88/usr/bin/hol88

binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate	
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
#	dh_perl
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure
